unit schInventarioClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_INVENTARIO = '{3AB4E732-7897-4CF1-8E79-E09DD13DC2E9}';
  RID_DETALLE_RESERVAS_INV = '{EE8DE96E-5709-43B7-9AB0-B67D3DFA1353}';

  { Data table names }
  nme_INVENTARIO = 'INVENTARIO';
  nme_DETALLE_RESERVAS_INV = 'DETALLE_RESERVAS_INV';

  { INVENTARIO fields }
  fld_INVENTARIOID = 'ID';
  fld_INVENTARIOID_ALMACEN = 'ID_ALMACEN';
  fld_INVENTARIOID_ARTICULO = 'ID_ARTICULO';
  fld_INVENTARIOALMACEN = 'ALMACEN';
  fld_INVENTARIOID_EMPRESA = 'ID_EMPRESA';
  fld_INVENTARIOREFERENCIA = 'REFERENCIA';
  fld_INVENTARIOFAMILIA = 'FAMILIA';
  fld_INVENTARIODESCRIPCION = 'DESCRIPCION';
  fld_INVENTARIOPRECIO_NETO = 'PRECIO_NETO';
  fld_INVENTARIOREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_INVENTARIOUNIDADES_ALMACEN = 'UNIDADES_ALMACEN';
  fld_INVENTARIOCOSTE_UNIDADES = 'COSTE_UNIDADES';
  fld_INVENTARIOSTOCK = 'STOCK';
  fld_INVENTARIORESERVA = 'RESERVA';
  fld_INVENTARIOPENDIENTE_RECEPCION = 'PENDIENTE_RECEPCION';
  fld_INVENTARIOCANTIDAD = 'CANTIDAD';
  fld_INVENTARIOFECHA_MOVIMIENTO = 'FECHA_MOVIMIENTO';
  fld_INVENTARIOCAUSA = 'CAUSA';
  fld_INVENTARIOTIPO = 'TIPO';

  { INVENTARIO field indexes }
  idx_INVENTARIOID = 0;
  idx_INVENTARIOID_ALMACEN = 1;
  idx_INVENTARIOID_ARTICULO = 2;
  idx_INVENTARIOALMACEN = 3;
  idx_INVENTARIOID_EMPRESA = 4;
  idx_INVENTARIOREFERENCIA = 5;
  idx_INVENTARIOFAMILIA = 6;
  idx_INVENTARIODESCRIPCION = 7;
  idx_INVENTARIOPRECIO_NETO = 8;
  idx_INVENTARIOREFERENCIA_PROVEEDOR = 9;
  idx_INVENTARIOUNIDADES_ALMACEN = 10;
  idx_INVENTARIOCOSTE_UNIDADES = 11;
  idx_INVENTARIOSTOCK = 12;
  idx_INVENTARIORESERVA = 13;
  idx_INVENTARIOPENDIENTE_RECEPCION = 14;
  idx_INVENTARIOCANTIDAD = 15;
  idx_INVENTARIOFECHA_MOVIMIENTO = 16;
  idx_INVENTARIOCAUSA = 17;
  idx_INVENTARIOTIPO = 18;

  { DETALLE_RESERVAS_INV fields }
  fld_DETALLE_RESERVAS_INVID_ALB = 'ID_ALB';
  fld_DETALLE_RESERVAS_INVID_EMPRESA = 'ID_EMPRESA';
  fld_DETALLE_RESERVAS_INVREFERENCIA_ALB = 'REFERENCIA_ALB';
  fld_DETALLE_RESERVAS_INVSITUACION_ALB = 'SITUACION_ALB';
  fld_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB = 'FECHA_PREVISTA_ENVIO_ALB';
  fld_DETALLE_RESERVAS_INVID_ALMACEN_ALB = 'ID_ALMACEN_ALB';
  fld_DETALLE_RESERVAS_INVALMACEN_ALB = 'ALMACEN_ALB';
  fld_DETALLE_RESERVAS_INVID_CLIENTE_ALB = 'ID_CLIENTE_ALB';
  fld_DETALLE_RESERVAS_INVCLIENTE_ALB = 'CLIENTE_ALB';
  fld_DETALLE_RESERVAS_INVID_ART = 'ID_ART';
  fld_DETALLE_RESERVAS_INVFAMILIA_ART = 'FAMILIA_ART';
  fld_DETALLE_RESERVAS_INVREFERENCIA_ART = 'REFERENCIA_ART';
  fld_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART = 'REFERENCIA_PROV_ART';
  fld_DETALLE_RESERVAS_INVDESCRIPCION_ART = 'DESCRIPCION_ART';
  fld_DETALLE_RESERVAS_INVCANTIDAD_ART = 'CANTIDAD_ART';

  { DETALLE_RESERVAS_INV field indexes }
  idx_DETALLE_RESERVAS_INVID_ALB = 0;
  idx_DETALLE_RESERVAS_INVID_EMPRESA = 1;
  idx_DETALLE_RESERVAS_INVREFERENCIA_ALB = 2;
  idx_DETALLE_RESERVAS_INVSITUACION_ALB = 3;
  idx_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB = 4;
  idx_DETALLE_RESERVAS_INVID_ALMACEN_ALB = 5;
  idx_DETALLE_RESERVAS_INVALMACEN_ALB = 6;
  idx_DETALLE_RESERVAS_INVID_CLIENTE_ALB = 7;
  idx_DETALLE_RESERVAS_INVCLIENTE_ALB = 8;
  idx_DETALLE_RESERVAS_INVID_ART = 9;
  idx_DETALLE_RESERVAS_INVFAMILIA_ART = 10;
  idx_DETALLE_RESERVAS_INVREFERENCIA_ART = 11;
  idx_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART = 12;
  idx_DETALLE_RESERVAS_INVDESCRIPCION_ART = 13;
  idx_DETALLE_RESERVAS_INVCANTIDAD_ART = 14;

type
  { IINVENTARIO }
  IINVENTARIO = interface(IDAStronglyTypedDataTable)
  ['{FF96221D-1DEB-42D7-9EB8-26DA6BD30F2A}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetID_ALMACENValue: Integer;
    procedure SetID_ALMACENValue(const aValue: Integer);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetALMACENValue: String;
    procedure SetALMACENValue(const aValue: String);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetFAMILIAValue: String;
    procedure SetFAMILIAValue(const aValue: String);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetPRECIO_NETOValue: Currency;
    procedure SetPRECIO_NETOValue(const aValue: Currency);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetUNIDADES_ALMACENValue: Integer;
    procedure SetUNIDADES_ALMACENValue(const aValue: Integer);
    function GetCOSTE_UNIDADESValue: Currency;
    procedure SetCOSTE_UNIDADESValue(const aValue: Currency);
    function GetSTOCKValue: Integer;
    procedure SetSTOCKValue(const aValue: Integer);
    function GetRESERVAValue: Integer;
    procedure SetRESERVAValue(const aValue: Integer);
    function GetPENDIENTE_RECEPCIONValue: Integer;
    procedure SetPENDIENTE_RECEPCIONValue(const aValue: Integer);
    function GetCANTIDADValue: Integer;
    procedure SetCANTIDADValue(const aValue: Integer);
    function GetFECHA_MOVIMIENTOValue: DateTime;
    procedure SetFECHA_MOVIMIENTOValue(const aValue: DateTime);
    function GetCAUSAValue: String;
    procedure SetCAUSAValue(const aValue: String);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ALMACEN: String read GetALMACENValue write SetALMACENValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property PRECIO_NETO: Currency read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property UNIDADES_ALMACEN: Integer read GetUNIDADES_ALMACENValue write SetUNIDADES_ALMACENValue;
    property COSTE_UNIDADES: Currency read GetCOSTE_UNIDADESValue write SetCOSTE_UNIDADESValue;
    property STOCK: Integer read GetSTOCKValue write SetSTOCKValue;
    property RESERVA: Integer read GetRESERVAValue write SetRESERVAValue;
    property PENDIENTE_RECEPCION: Integer read GetPENDIENTE_RECEPCIONValue write SetPENDIENTE_RECEPCIONValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property FECHA_MOVIMIENTO: DateTime read GetFECHA_MOVIMIENTOValue write SetFECHA_MOVIMIENTOValue;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
  end;

  { TINVENTARIODataTableRules }
  TINVENTARIODataTableRules = class(TDADataTableRules, IINVENTARIO)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetID_ALMACENValue: Integer; virtual;
    procedure SetID_ALMACENValue(const aValue: Integer); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetALMACENValue: String; virtual;
    procedure SetALMACENValue(const aValue: String); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetFAMILIAValue: String; virtual;
    procedure SetFAMILIAValue(const aValue: String); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetPRECIO_NETOValue: Currency; virtual;
    procedure SetPRECIO_NETOValue(const aValue: Currency); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetUNIDADES_ALMACENValue: Integer; virtual;
    procedure SetUNIDADES_ALMACENValue(const aValue: Integer); virtual;
    function GetCOSTE_UNIDADESValue: Currency; virtual;
    procedure SetCOSTE_UNIDADESValue(const aValue: Currency); virtual;
    function GetSTOCKValue: Integer; virtual;
    procedure SetSTOCKValue(const aValue: Integer); virtual;
    function GetRESERVAValue: Integer; virtual;
    procedure SetRESERVAValue(const aValue: Integer); virtual;
    function GetPENDIENTE_RECEPCIONValue: Integer; virtual;
    procedure SetPENDIENTE_RECEPCIONValue(const aValue: Integer); virtual;
    function GetCANTIDADValue: Integer; virtual;
    procedure SetCANTIDADValue(const aValue: Integer); virtual;
    function GetFECHA_MOVIMIENTOValue: DateTime; virtual;
    procedure SetFECHA_MOVIMIENTOValue(const aValue: DateTime); virtual;
    function GetCAUSAValue: String; virtual;
    procedure SetCAUSAValue(const aValue: String); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ALMACEN: String read GetALMACENValue write SetALMACENValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property FAMILIA: String read GetFAMILIAValue write SetFAMILIAValue;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property PRECIO_NETO: Currency read GetPRECIO_NETOValue write SetPRECIO_NETOValue;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property UNIDADES_ALMACEN: Integer read GetUNIDADES_ALMACENValue write SetUNIDADES_ALMACENValue;
    property COSTE_UNIDADES: Currency read GetCOSTE_UNIDADESValue write SetCOSTE_UNIDADESValue;
    property STOCK: Integer read GetSTOCKValue write SetSTOCKValue;
    property RESERVA: Integer read GetRESERVAValue write SetRESERVAValue;
    property PENDIENTE_RECEPCION: Integer read GetPENDIENTE_RECEPCIONValue write SetPENDIENTE_RECEPCIONValue;
    property CANTIDAD: Integer read GetCANTIDADValue write SetCANTIDADValue;
    property FECHA_MOVIMIENTO: DateTime read GetFECHA_MOVIMIENTOValue write SetFECHA_MOVIMIENTOValue;
    property CAUSA: String read GetCAUSAValue write SetCAUSAValue;
    property TIPO: String read GetTIPOValue write SetTIPOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IDETALLE_RESERVAS_INV }
  IDETALLE_RESERVAS_INV = interface(IDAStronglyTypedDataTable)
  ['{D0FB81D1-6746-4FCF-94C2-AE823C8382C8}']
    { Property getters and setters }
    function GetID_ALBValue: Integer;
    procedure SetID_ALBValue(const aValue: Integer);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetREFERENCIA_ALBValue: String;
    procedure SetREFERENCIA_ALBValue(const aValue: String);
    function GetSITUACION_ALBValue: String;
    procedure SetSITUACION_ALBValue(const aValue: String);
    function GetFECHA_PREVISTA_ENVIO_ALBValue: DateTime;
    procedure SetFECHA_PREVISTA_ENVIO_ALBValue(const aValue: DateTime);
    function GetID_ALMACEN_ALBValue: Integer;
    procedure SetID_ALMACEN_ALBValue(const aValue: Integer);
    function GetALMACEN_ALBValue: String;
    procedure SetALMACEN_ALBValue(const aValue: String);
    function GetID_CLIENTE_ALBValue: Integer;
    procedure SetID_CLIENTE_ALBValue(const aValue: Integer);
    function GetCLIENTE_ALBValue: String;
    procedure SetCLIENTE_ALBValue(const aValue: String);
    function GetID_ARTValue: Integer;
    procedure SetID_ARTValue(const aValue: Integer);
    function GetFAMILIA_ARTValue: String;
    procedure SetFAMILIA_ARTValue(const aValue: String);
    function GetREFERENCIA_ARTValue: String;
    procedure SetREFERENCIA_ARTValue(const aValue: String);
    function GetREFERENCIA_PROV_ARTValue: String;
    procedure SetREFERENCIA_PROV_ARTValue(const aValue: String);
    function GetDESCRIPCION_ARTValue: String;
    procedure SetDESCRIPCION_ARTValue(const aValue: String);
    function GetCANTIDAD_ARTValue: Integer;
    procedure SetCANTIDAD_ARTValue(const aValue: Integer);


    { Properties }
    property ID_ALB: Integer read GetID_ALBValue write SetID_ALBValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_ALB: String read GetREFERENCIA_ALBValue write SetREFERENCIA_ALBValue;
    property SITUACION_ALB: String read GetSITUACION_ALBValue write SetSITUACION_ALBValue;
    property FECHA_PREVISTA_ENVIO_ALB: DateTime read GetFECHA_PREVISTA_ENVIO_ALBValue write SetFECHA_PREVISTA_ENVIO_ALBValue;
    property ID_ALMACEN_ALB: Integer read GetID_ALMACEN_ALBValue write SetID_ALMACEN_ALBValue;
    property ALMACEN_ALB: String read GetALMACEN_ALBValue write SetALMACEN_ALBValue;
    property ID_CLIENTE_ALB: Integer read GetID_CLIENTE_ALBValue write SetID_CLIENTE_ALBValue;
    property CLIENTE_ALB: String read GetCLIENTE_ALBValue write SetCLIENTE_ALBValue;
    property ID_ART: Integer read GetID_ARTValue write SetID_ARTValue;
    property FAMILIA_ART: String read GetFAMILIA_ARTValue write SetFAMILIA_ARTValue;
    property REFERENCIA_ART: String read GetREFERENCIA_ARTValue write SetREFERENCIA_ARTValue;
    property REFERENCIA_PROV_ART: String read GetREFERENCIA_PROV_ARTValue write SetREFERENCIA_PROV_ARTValue;
    property DESCRIPCION_ART: String read GetDESCRIPCION_ARTValue write SetDESCRIPCION_ARTValue;
    property CANTIDAD_ART: Integer read GetCANTIDAD_ARTValue write SetCANTIDAD_ARTValue;
  end;

  { TDETALLE_RESERVAS_INVDataTableRules }
  TDETALLE_RESERVAS_INVDataTableRules = class(TDADataTableRules, IDETALLE_RESERVAS_INV)
  private
  protected
    { Property getters and setters }
    function GetID_ALBValue: Integer; virtual;
    procedure SetID_ALBValue(const aValue: Integer); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetREFERENCIA_ALBValue: String; virtual;
    procedure SetREFERENCIA_ALBValue(const aValue: String); virtual;
    function GetSITUACION_ALBValue: String; virtual;
    procedure SetSITUACION_ALBValue(const aValue: String); virtual;
    function GetFECHA_PREVISTA_ENVIO_ALBValue: DateTime; virtual;
    procedure SetFECHA_PREVISTA_ENVIO_ALBValue(const aValue: DateTime); virtual;
    function GetID_ALMACEN_ALBValue: Integer; virtual;
    procedure SetID_ALMACEN_ALBValue(const aValue: Integer); virtual;
    function GetALMACEN_ALBValue: String; virtual;
    procedure SetALMACEN_ALBValue(const aValue: String); virtual;
    function GetID_CLIENTE_ALBValue: Integer; virtual;
    procedure SetID_CLIENTE_ALBValue(const aValue: Integer); virtual;
    function GetCLIENTE_ALBValue: String; virtual;
    procedure SetCLIENTE_ALBValue(const aValue: String); virtual;
    function GetID_ARTValue: Integer; virtual;
    procedure SetID_ARTValue(const aValue: Integer); virtual;
    function GetFAMILIA_ARTValue: String; virtual;
    procedure SetFAMILIA_ARTValue(const aValue: String); virtual;
    function GetREFERENCIA_ARTValue: String; virtual;
    procedure SetREFERENCIA_ARTValue(const aValue: String); virtual;
    function GetREFERENCIA_PROV_ARTValue: String; virtual;
    procedure SetREFERENCIA_PROV_ARTValue(const aValue: String); virtual;
    function GetDESCRIPCION_ARTValue: String; virtual;
    procedure SetDESCRIPCION_ARTValue(const aValue: String); virtual;
    function GetCANTIDAD_ARTValue: Integer; virtual;
    procedure SetCANTIDAD_ARTValue(const aValue: Integer); virtual;

    { Properties }
    property ID_ALB: Integer read GetID_ALBValue write SetID_ALBValue;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property REFERENCIA_ALB: String read GetREFERENCIA_ALBValue write SetREFERENCIA_ALBValue;
    property SITUACION_ALB: String read GetSITUACION_ALBValue write SetSITUACION_ALBValue;
    property FECHA_PREVISTA_ENVIO_ALB: DateTime read GetFECHA_PREVISTA_ENVIO_ALBValue write SetFECHA_PREVISTA_ENVIO_ALBValue;
    property ID_ALMACEN_ALB: Integer read GetID_ALMACEN_ALBValue write SetID_ALMACEN_ALBValue;
    property ALMACEN_ALB: String read GetALMACEN_ALBValue write SetALMACEN_ALBValue;
    property ID_CLIENTE_ALB: Integer read GetID_CLIENTE_ALBValue write SetID_CLIENTE_ALBValue;
    property CLIENTE_ALB: String read GetCLIENTE_ALBValue write SetCLIENTE_ALBValue;
    property ID_ART: Integer read GetID_ARTValue write SetID_ARTValue;
    property FAMILIA_ART: String read GetFAMILIA_ARTValue write SetFAMILIA_ARTValue;
    property REFERENCIA_ART: String read GetREFERENCIA_ARTValue write SetREFERENCIA_ARTValue;
    property REFERENCIA_PROV_ART: String read GetREFERENCIA_PROV_ARTValue write SetREFERENCIA_PROV_ARTValue;
    property DESCRIPCION_ART: String read GetDESCRIPCION_ARTValue write SetDESCRIPCION_ARTValue;
    property CANTIDAD_ART: Integer read GetCANTIDAD_ARTValue write SetCANTIDAD_ARTValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TINVENTARIODataTableRules }
constructor TINVENTARIODataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TINVENTARIODataTableRules.Destroy;
begin
  inherited;
end;

function TINVENTARIODataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetID_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID_ALMACEN].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetID_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID_ALMACEN].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID_ARTICULO].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID_ARTICULO].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetALMACENValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOALMACEN].AsString;
end;

procedure TINVENTARIODataTableRules.SetALMACENValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOALMACEN].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOID_EMPRESA].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOID_EMPRESA].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOREFERENCIA].AsString;
end;

procedure TINVENTARIODataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOREFERENCIA].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetFAMILIAValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOFAMILIA].AsString;
end;

procedure TINVENTARIODataTableRules.SetFAMILIAValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOFAMILIA].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIODESCRIPCION].AsString;
end;

procedure TINVENTARIODataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIODESCRIPCION].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetPRECIO_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_INVENTARIOPRECIO_NETO].AsCurrency;
end;

procedure TINVENTARIODataTableRules.SetPRECIO_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_INVENTARIOPRECIO_NETO].AsCurrency := aValue;
end;

function TINVENTARIODataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOREFERENCIA_PROVEEDOR].AsString;
end;

procedure TINVENTARIODataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetUNIDADES_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOUNIDADES_ALMACEN].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetUNIDADES_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOUNIDADES_ALMACEN].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetCOSTE_UNIDADESValue: Currency;
begin
  result := DataTable.Fields[idx_INVENTARIOCOSTE_UNIDADES].AsCurrency;
end;

procedure TINVENTARIODataTableRules.SetCOSTE_UNIDADESValue(const aValue: Currency);
begin
  DataTable.Fields[idx_INVENTARIOCOSTE_UNIDADES].AsCurrency := aValue;
end;

function TINVENTARIODataTableRules.GetSTOCKValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOSTOCK].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetSTOCKValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOSTOCK].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetRESERVAValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIORESERVA].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetRESERVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIORESERVA].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetPENDIENTE_RECEPCIONValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOPENDIENTE_RECEPCION].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetPENDIENTE_RECEPCIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOPENDIENTE_RECEPCION].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetCANTIDADValue: Integer;
begin
  result := DataTable.Fields[idx_INVENTARIOCANTIDAD].AsInteger;
end;

procedure TINVENTARIODataTableRules.SetCANTIDADValue(const aValue: Integer);
begin
  DataTable.Fields[idx_INVENTARIOCANTIDAD].AsInteger := aValue;
end;

function TINVENTARIODataTableRules.GetFECHA_MOVIMIENTOValue: DateTime;
begin
  result := DataTable.Fields[idx_INVENTARIOFECHA_MOVIMIENTO].AsDateTime;
end;

procedure TINVENTARIODataTableRules.SetFECHA_MOVIMIENTOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_INVENTARIOFECHA_MOVIMIENTO].AsDateTime := aValue;
end;

function TINVENTARIODataTableRules.GetCAUSAValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOCAUSA].AsString;
end;

procedure TINVENTARIODataTableRules.SetCAUSAValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOCAUSA].AsString := aValue;
end;

function TINVENTARIODataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_INVENTARIOTIPO].AsString;
end;

procedure TINVENTARIODataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_INVENTARIOTIPO].AsString := aValue;
end;


{ TDETALLE_RESERVAS_INVDataTableRules }
constructor TDETALLE_RESERVAS_INVDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TDETALLE_RESERVAS_INVDataTableRules.Destroy;
begin
  inherited;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_ALBValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALB].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_ALBValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALB].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_EMPRESA].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_EMPRESA].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetREFERENCIA_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetREFERENCIA_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetSITUACION_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVSITUACION_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetSITUACION_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVSITUACION_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetFECHA_PREVISTA_ENVIO_ALBValue: DateTime;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB].AsDateTime;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetFECHA_PREVISTA_ENVIO_ALBValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVFECHA_PREVISTA_ENVIO_ALB].AsDateTime := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_ALMACEN_ALBValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALMACEN_ALB].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_ALMACEN_ALBValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ALMACEN_ALB].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetALMACEN_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVALMACEN_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetALMACEN_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVALMACEN_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_CLIENTE_ALBValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_CLIENTE_ALB].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_CLIENTE_ALBValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_CLIENTE_ALB].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetCLIENTE_ALBValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVCLIENTE_ALB].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetCLIENTE_ALBValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVCLIENTE_ALB].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetID_ARTValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ART].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetID_ARTValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVID_ART].AsInteger := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetFAMILIA_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVFAMILIA_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetFAMILIA_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVFAMILIA_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetREFERENCIA_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetREFERENCIA_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetREFERENCIA_PROV_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetREFERENCIA_PROV_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVREFERENCIA_PROV_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetDESCRIPCION_ARTValue: String;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVDESCRIPCION_ART].AsString;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetDESCRIPCION_ARTValue(const aValue: String);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVDESCRIPCION_ART].AsString := aValue;
end;

function TDETALLE_RESERVAS_INVDataTableRules.GetCANTIDAD_ARTValue: Integer;
begin
  result := DataTable.Fields[idx_DETALLE_RESERVAS_INVCANTIDAD_ART].AsInteger;
end;

procedure TDETALLE_RESERVAS_INVDataTableRules.SetCANTIDAD_ARTValue(const aValue: Integer);
begin
  DataTable.Fields[idx_DETALLE_RESERVAS_INVCANTIDAD_ART].AsInteger := aValue;
end;


initialization
  RegisterDataTableRules(RID_INVENTARIO, TINVENTARIODataTableRules);
  RegisterDataTableRules(RID_DETALLE_RESERVAS_INV, TDETALLE_RESERVAS_INVDataTableRules);

end.
